/**
 * This is the name of the platform that users will use to register the plugin in the Homebridge config.json
 */
export declare const PLATFORM_NAME = "GreeAirConditioner";
export declare const ACCESSORY_NAME = "AirConditioner";
export declare type SwitchName = 'power' | 'verticalSwing' | 'horizontalSwing' | 'quietMode' | 'powerfulMode' | 'light' | 'dryMode' | 'fanMode' | 'sleepMode';
/**
 * This must match the name of your plugin as defined the package.json
 */
export declare const PLUGIN_NAME = "homebridge-gree-air-conditioner";
export interface LocaleMessages {
    power: string;
    mode: string;
    verticalSwing: string;
    horizontalSwing: string;
    quietMode: string;
    powerfulMode: string;
    light: string;
    dryMode: string;
    fanMode: string;
    fanSpeed: string;
    sleepMode: string;
}
export interface DeviceConfig {
    name?: string;
    minimumTargetTemperature: number;
    maximumTargetTemperature: number;
    sensorOffset: number;
    defaultSpeed: number;
    defaultVerticalSwing?: number;
    defaultHorizontalSwing?: number;
    statusUpdateInterval: number;
    switches: string;
    disabled?: boolean;
}
export declare const DEFAULT_DEVICE_CONFIG: DeviceConfig;
export declare const DEFAULT_PLATFORM_CONFIG: {
    name: string;
    port: number;
    scanCount: number;
    language: string;
    scanTimout: number;
    scanAddress: string;
    defaultValue: DeviceConfig;
    devices: never[];
};
export declare const UDP_SCAN_PORT = 7000;
//# sourceMappingURL=settings.d.ts.map